<?php
class ModelExtensionModuleSmsIppanel extends Model {
	

    /**
     * افزودن تیک ارسال پیامک در صفحه تغییر وضعیت سفارش
     */
    public function SmsIppanel_order_checkbox($css_class_left = "col-sm-2", $css_class_right = "col-sm-10") {

        $this->load->language('extension/module/smsippanel');
        $data['smsippanel_entry_notify_by_sms_label'] = $this->language->get('smsippanel_entry_notify_by_sms_label');

         $data['css_class_left']  = $css_class_left;
         $data['css_class_right'] = $css_class_right;
		return $this->load->view('extension/module/smsippanel_orderinfo_checkbox', $data);
    }

	
    /**
     * بررسی درخواست ارسال پیامک توسط کاربر در صفحه سفارش
     */
    public function build_request_params_in_order_status_update_ajax_request(){

        /*
         *  + '&notify_by_sms=' + ($('input[name=\'notify_by_sms\']').prop('checked') ? 1 : 0) + '&notify=' +
         */
        $params = "'&notify_by_sms=' + ($('input[name=\'notify_by_sms\']').prop('checked') ? 1 : 0)" ;

        return $params;
    }
	/* افزودن قالب به دیتابیس*/
	public function addTemplate($data) {
		$this->db->query("INSERT INTO " . DB_PREFIX . "smsippanel_template SET store_id = '" . (int)$data['store_id'] . "', type = '" . $this->db->escape($data['type']) . "', name = '" . $this->db->escape($data['name']) . "', bcc = '" . $this->db->escape($data['bcc']) . "'");
		
		$template_id = $this->db->getLastId();
		
		foreach ($data['description'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "smsippanel_template_message SET sms_template_id = '" . (int)$template_id . "', language_id = '" . (int)$language_id . "', message = '" . $this->db->escape($value['message']) . "', adminmessage = '" . $this->db->escape($value['adminmessage']) . "'");
		}
	}
	/* ورود ویرایش قالب در دیتابیس*/
	public function editTemplate($template_id, $data) {
		$this->db->query("UPDATE " . DB_PREFIX . "smsippanel_template SET store_id = '" . (int)$data['store_id'] . "', type = '" . $this->db->escape($data['type']) . "', name = '" . $this->db->escape($data['name']) . "', bcc = '" . $this->db->escape($data['bcc']) . "' WHERE sms_template_id = '" . (int)$template_id . "'");
		
		$this->db->query("DELETE FROM " . DB_PREFIX . "smsippanel_template_message WHERE sms_template_id = '" . (int)$template_id . "'");
		
		foreach ($data['description'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "smsippanel_template_message SET sms_template_id = '" . (int)$template_id . "', language_id = '" . (int)$language_id . "', message = '" . $this->db->escape($value['message']) . "', adminmessage = '" . $this->db->escape($value['adminmessage']) . "'");
		}
	}
	/* حذف قالب از دیتابیس*/
	public function deleteTemplate($template_id) {
		$this->db->query("DELETE FROM " . DB_PREFIX . "smsippanel_template WHERE sms_template_id = '" . (int)$template_id . "'");
		$this->db->query("DELETE FROM " . DB_PREFIX . "smsippanel_template_message WHERE sms_template_id = '" . (int)$template_id . "'");
	}
	/* دریافت  یک قالب از دیتابیس*/
	public function getTemplate($template_id) { 
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "smsippanel_template WHERE sms_template_id = '" . (int)$template_id . "'");
		
		if ($query->num_rows) {
			$description = $this->db->query("SELECT * FROM " . DB_PREFIX . "smsippanel_template_message WHERE sms_template_id = '" . (int)$template_id . "'");
			
			$description_data = array();
			
			foreach ($description->rows as $description) {
				$description_data[$description['language_id']] = array(
					'message'		=> $description['message'],
					'adminmessage'		=> $description['adminmessage']
				);
			}
			
			return array(
				'sms_template_id'	=> $query->row['sms_template_id'],
				'type'				=> $query->row['type'],
				'store_id'			=> $query->row['store_id'],
				'name'				=> $query->row['name'],
				'bcc'				=> $query->row['bcc'],
				'description'		=> $description_data
			);
		} else {
			return false;
		}
	}
	/* دریافت همه قالب ها از دیتابیس */
	public function getTemplates($data = array()) {
		$sql = "SELECT * FROM " . DB_PREFIX . "smsippanel_template";
		
		$sort_data = array(
			'name',
			'type'
		);	
		
		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];	
		} else {
			$sql .= " ORDER BY name";	
		}
		
		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}
		
		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}					

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}	
		
			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}		
		
		$query = $this->db->query($sql);

		return $query->rows;
	}
	/* دریافت تعداد قالب ها از دیتابیس*/
	public function getTotalTemplates() {
      	$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "smsippanel_template");
		
		return $query->row['total'];
	}
	/* دریافت متن پیامک قالب ها از دیتابیس */
	private function getSMSTemplates($type, $store_id) { 
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "smsippanel_template st LEFT JOIN " . DB_PREFIX . "smsippanel_template_message stm ON st.sms_template_id = stm.sms_template_id WHERE type = '" . $this->db->escape($type) . "' AND store_id = '" . (int)$store_id . "' AND language_id = '" . (int)$this->config->get('config_language_id') . "'");
		
		return $query->rows;
	}
	/* جستجوی متغیرها در متن پیامک */
	private function getSearch($type) {
		if ($type == 'register') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{password}'
			);
		} elseif ($type == 'affiliate') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{password}'
			);
		} elseif ($type == 'affiliate_transaction') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{commission}',
				'{total_commission}'
			);
		} elseif ($type == 'affiliate_approve') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}'
			);
		} elseif ($type == 'forgotten') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{password}'
			);
		} elseif ($type == 'order') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{order_id}',
				'{date_added}',
				'{payment_method}',
				'{shipping_method}',
				'{ip}',
				'{order_comment}',
				'{payment_address}',
				'{shipping_address}',
				'{products}'
			);
		} elseif ($type == 'reward') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{points}',
				'{total_points}'
			);
		} elseif ($type == 'account_approve') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}'
			);
		} elseif ($type == 'account_transaction') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{credits}',
				'{total_credits}'
			);
		} else {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{order_id}',
				'{date_added}',
				'{payment_method}',
				'{shipping_method}',
				'{ip}',
				'{order_comment}',
				'{payment_address}',
				'{shipping_address}',
				'{products}'
			);
		}
	
		return $search;
	}
	/* جایگذاری مقدار متغیرهای پیامک و ارسال پیامک */
	public function parseSMS($type, $store_id, $number, $replace) {
		$number = preg_replace('/[^0-9]/', '', $number);
		if($type == 'send_sms'){
			$this->sendSMS($number, $replace);
		}else{
			$templates = $this->getSMSTemplates($type, $store_id);
			$template_data = false;
			
			$template_data = false;
			foreach ($templates as $template) {
				$template_data = $template;
			}
		
			if ($template_data && !empty($template_data['message'])) {
				$search = $this->getSearch($type);
				
				$message = strip_tags(str_replace($search, $replace, html_entity_decode($template_data['message'])));
				
				$this->sendSMS($number, $message);
				if($template_data['bcc'] && !empty($template_data['adminmessage'])){
					$numbers = explode(',', $template_data['bcc']);
					$adminmessage = strip_tags(str_replace($search, $replace, html_entity_decode($template_data['adminmessage'])));
					foreach ($numbers as $number) {
						$this->sendSMS($number, $adminmessage);
					}
				}
			} else {
				return false;
			}
		}
	}
	/* ارسال پیامک به وب سرویس */
	public function sendSMS($receiver = null, $message = null) {
		$response = false;
		$username = trim($this->config->get('smsippanel_username'));
		$password = trim($this->config->get('smsippanel_password'));
		$from     = trim($this->config->get('smsippanel_default_from'));
		$debug    = $this->config->get('smsippanel_debug');
		$massage  = str_replace(array('https://','http://','www.'), array('','',''), $message);
		if($debug == 1){
			$result = "SMS DEBUG(admin): Reciver: {$receiver} - message : {$massage}";
			error_log($result);
			$this->log->write($result);
			$this->session->data['success'] = $result;
			return $result;
		}
		if ( empty( $username ) || empty( $password ) || empty( $from ) ||  empty( $receiver ) ||  empty( $massage ) ) {
			return $response;
		}

		if(is_array($receiver)) $to = $receiver; else $to = explode(',',$receiver);
		$massage = str_replace('patterncode:','pcode:',strip_tags(trim($massage)));
		if (substr( $massage, 0, 5 ) === "pcode"){
		    $massage = str_replace("\r\n",';',$massage);
		    $massage = str_replace("\n",';',$massage);
			$splited = explode(';', $massage);
			$patterncodeArray = explode(':', $splited[0]);
			$patterncode = trim($patterncodeArray[1]);
			unset($splited[0]);
			$input_data = array();
			foreach($splited as $parm){
			  $splited_parm = explode(':', $parm);
			  $input_data[trim($splited_parm[0])] = trim($splited_parm[1]);
			}
			$url = "/patterns/pattern?username=".$username."&password=".urlencode($password)."&from=$from&to=".json_encode($to)."&input_data=".urlencode(json_encode($input_data))."&pattern_code=".$patterncode;
			//error_log($url);
			$result = $this->cUrl( $url, array(), 'GET' );

			if ( ! empty( $result ) && is_numeric( $result ) ) {
				$response = true;
			} else {
				$this->log->write($this->getErrors($res_code));
				$this->session->data['warning'] = $this->getErrors($res_code);
			    error_log($res_code . ':' .$this->getErrors($res_code));
				$response = $res_code . ':' .$this->getErrors($res_code);
			}
			return $response;
		}else{
			$url = "/services.jspd";
			$params = array
						(
							'uname'=>$username,
							'pass'=>$password,
							'from'=>$from,
							'message'=>$massage,
							'to'=>json_encode($to),
							'op'=>'send'
						);

			$result = $this->cUrl( $url, $params, 'POST' );
			$result2 = json_decode($result);
			$res_code = $result2[0];
			$res_data = $result2[1];
			if ($res_code == '0'){
				$response = true;
			} else {
				$this->log->write($this->getErrors($res_code));
				$this->session->data['warning'] = $this->getErrors($res_code);
			    error_log($res_code . ':' .$this->getErrors($res_code));
				$response = $res_code . ':' .$this->getErrors($res_code);
			}
			return $response;
		}
	}
	/* چک کردن پترن از وب سرویس*/
	public function checkPattern($patternCode = null){

		if($patternCode){
			$params = array(
				'uname' => trim($this->config->get('smsippanel_username')),
				'pass'  => trim($this->config->get('smsippanel_password')),
				'patternCode'=> trim($patternCode),
				'op'=> 'getPatternParams',
			);
			$url = "/api/select";
			$result = $this->cUrl( $url, json_encode($params), 'POST' );
			$response = json_decode($result,true);
			if (is_array($response) && isset($response['status']['code'])) {
				$status = $response['status']['code'];
				if($status == 0){
					$patternMessage = $response['data']['patternMessage'];
					$patternParams = $response['data']['patternParams'];
					$result = array('status'=>$status,'message'=>$patternMessage,'vars'=>$patternParams);
				} else {
					$result = array('status'=>$status,'message'=>$this->getErrors($status));
				}
			}else{
				$result = array('status'=>-1,'message'=>'اشکالی در دریافت اطلاعات پترن به وجود آمد.'); 
			}
			return $result;
		}else{
			return '-1';
		}
		die();
	}
	/* دریافت باقیمانده اعتبار از وب سرویس */
	public function getCredit($username = null,$password = null ) {
		$url = "/services.jspd";
		$params = array
					(
						'uname' => $username,
						'pass'  => $password,
						'op'    => 'credit'
					);
		$result = $this->cUrl( $url, $params, 'POST' );
		$response = json_decode($result);
		$res_code = $response[0];
		$res_data = $response[1];
		if ($res_code == '0'){
			return round($res_data);
		}else{
			return $this->getErrors($res_code);
		}
	}
	/* دریافت اطلاعات کاربر پنل پیامک */
	public function userPanel() {
		$url = "/services.jspd";
		$params = array
					(
						'uname' => trim($this->config->get('smsippanel_username')),
						'pass'  => trim($this->config->get('smsippanel_password')),
						'op'    => 'usertime'
					);
		$result = $this->cUrl( $url, $params, 'POST' );
		$response = json_decode($result);
		$res_code = $response[0];
		$res_data = $response[1];
		if ($res_code == '0'){
			$time = strtotime($res_data);
			if($time){
				$now = new DateTime;
				$expire = new DateTime('@'.$time);
				$diff = $now->diff($expire);
				$remaindays = $diff->days;
			} else {
				$remaindays = 'بدون تاریخ انقضا';
			}
			return $remaindays;
		}else{
			return $this->getErrors($res_code);
		}
	}
	/* دستور ارتباط با وب سرویس سامانه پیامک*/
	private function cUrl( $url, $params = array() , $method = 'POST' ) {
		$domain     = trim($this->config->get('smsippanel_domain'));
		if(empty($domain)) $domain = "https://ippanel.com";
		$handler = curl_init($domain.$url);        
		curl_setopt($handler, CURLOPT_CONNECTTIMEOUT, 5); 
		curl_setopt($handler, CURLOPT_TIMEOUT, 20);
		curl_setopt($handler, CURLOPT_CUSTOMREQUEST, $method);
		if($method == 'POST') curl_setopt($handler, CURLOPT_POSTFIELDS, $params);
		curl_setopt($handler, CURLOPT_RETURNTRANSFER, true);
		$result = curl_exec($handler); 
		return $result;
	}
	/* لیست خطاهای وب سرویس*/
	private function getErrors($error){
		$errorCodes = array(
			'0'  => 'عملیات با موفقیت انجام شده است.',
			'1'  => 'متن پیام خالی می باشد.',
			'2'  => 'کاربر محدود گردیده است.',
			'3'  => 'خط به شما تعلق ندارد.',
			'4'  => 'گیرندگان خالی است.',
			'5'  => 'اعتبار کافی نیست.',
			'7'  => 'خط مورد نظر برای ارسال انبوه مناسب نمیباشد.',
			'9'  => 'خط مورد نظر در این ساعت امکان ارسال ندارد.',
			'98' => 'حداکثر تعداد گیرنده رعایت نشدهه است.',
			'99' => 'اپراتور خط ارسالی قطع می باشد.',
			'21' => 'پسوند فایل صوتی نامعتبر است.',
			'22' => 'سایز فایل صوتی نامعتبر است.',
			'23' => 'تعداد تالش در پیام صوتی نامعتبر است.',
			'100' => 'شماره مخاطب دفترچه تلفن نامعتبر می باشد.',
			'101' => 'شماره مخاطب در دفترچه تلفن وجود دارد.',
			'102' => 'شماره مخاطب با موفقیت در دفترچه تلفن ذخیره گردید.',
			'111' => 'حداکثر تعداد گیرنده برای ارسال پیام صوتی رعایت نشده است.',
			'131' => 'تعداد تالش در پیام صوتی باید یکبار باشد.',
			'132' => 'آدرس فایل صوتی وارد نگردیده است.',
			'301' => 'از حرف ویژه در نام کاربری استفاده گردیده است.',
			'302' => 'قیمت گذاری انجام نگریدهه است.',
			'303' => 'نام کاربری وارد نگردیده است.',
			'304' => 'نام کاربری قبال انتخاب گردیده است.',
			'305' => 'نام کاربری وارد نگردیده است.',
			'306' => 'کد ملی وارد نگردیده است.',
			'307' => 'کد ملی به خطا وارد شده است.',
			'308' => 'شماره شناسنامه نا معتبر است.',
			'309' => 'شماره شناسنامه وارد نگردیده است.',
			'310' => 'ایمیل کاربر وارد نگردیده است.',
			'311' => 'شماره تلفن وارد نگردیده است.',
			'312' => 'تلفن به درستی وارد نگردیده است.',
			'313' => 'آدرس شما وارد نگردیده است.',
			'314' => 'شماره موبایل را وارد نکرده اید.',
			'315' => 'شماره موبایل به نادرستی وارد گردیده است.',
			'316' => 'سطح دسترسی به نادرستی وارد گردیده است.',
			'317' => 'کلمه عبور وارد نگردیده است.',
			'404' => 'پترن در دسترس نیست.',
			'455' => 'ارسال در آینده برای کد بالک ارسالی لغو شد.',
			'456' => 'کد بالک ارسالی نامعتبر است.',
			'458' => 'کد تیکت نامعتبر است.',
			'964' => 'شما دسترسی نمایندگی ندارید.',
			'962' => 'نام کاربری یا کلمه عبور نادرست می باشد.',
			'963' => 'دسترسی نامعتبر می باشد.',
			'971' => 'پترن ارسالی نامعتبر است.',
			'970' => 'پارامتر های ارسالی برای پترن نامعتبر است.',
			'972' => 'دریافت کننده برای ارسال پترن نامعتبر می باشد.',
			'992' => 'ارسال پیام از ساعت 8 تا 23 می باشد.',
			'993' => 'دفترچه تلفن باید یک آرایه باشد',
			'994' => 'لطفا تصویری از کارت بانکی خود را از منو مدارک ارسال کنید',
			'995' => 'جهت ارسال با خطوط اشتراکی سامانه، لطفا شماره کارت بانکیه خود را به دلیل تکمیل فرایند  احراز هویت از بخش ارسال مدارک ثبت نمایید.',
			'996' => 'پترن فعال نیست.',
			'997' => 'شما اجازه ارسال از این پترن را ندارید.ه',
			'998' => 'کارت ملی یا کارت بانکی شما تایید نشده است.',
			'1001' => 'فرمت نام کاربری درست نمی باشد)حداقله ۵ کاراکتر، فقط حروف و اعداد(.',
			'1002' => 'گذر واژه خیلی ساده می باشد)حداقل ۸ کاراکتر بوده و نام کاربری،',
			'ایمی' => ' و شماره موبایل در آن وجود نداشته باشد(.',
			'1003' => 'مشکل در ثبت، با پشتیبانی تماس بگیرید.',
			'1004' => 'مشکل در ثبت، با پشتیبانی تماس بگیرید.',
			'1005' => 'مشکل در ثبت، با پشتیبانی تماس بگیرید.',
			'1006' => 'تاریخ ارسال پیام برای گذشته می باشد، لطفا تاریخ ارسال پیام را به درستی وارد نمایید.ه',
		);
		return (isset($errorCodes[$error])) ? $errorCodes[$error] : 'اشکال تعریف نشده با کد :' . $error;
	}
}
